<?php
/*
  $Id: ticket_view.php,v 1.6 2003/07/13 20:22:02 hook Exp $

  OSC-SupportTicketSystem
  Copyright (c) 2003 Henri Schmidhuber IN-Solution
   Updated by Foster 10/01/2020  
 
  Contribution based on:

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
*/

  require('includes/application_top.php');
 if (!tep_session_is_registered('customer_id') && $_GET['login']=="yes") {
    $navigation->set_snapshot();
    tep_redirect(tep_href_link('login.php', '', 'SSL'));
  }
  require('includes/languages/' . $language . '/' . 'ticket_view.php');

  $ticket_departments = array();
  $ticket_department_array = array();
  $ticket_department_query = tep_db_query("select ticket_department_id, ticket_department_name from ticket_department where ticket_language_id = '" . $languages_id . "'");
  while ($ticket_department = tep_db_fetch_array($ticket_department_query)) {
    $ticket_departments[] = array('id' => $ticket_department['ticket_department_id'],
	'text' => $ticket_department['ticket_department_name']);
    $ticket_department_array[$ticket_department['ticket_department_id']] = $ticket_department['ticket_department_name'];
  }

  $ticket_prioritys = array();
  $ticket_priority_array = array();
  $ticket_priority_query = tep_db_query("select ticket_priority_id, ticket_priority_name from ticket_priority where ticket_language_id = '" . $languages_id . "'");
  while ($ticket_priority = tep_db_fetch_array($ticket_priority_query)) {
    $ticket_prioritys[] = array('id' => $ticket_priority['ticket_priority_id'],
	'text' => $ticket_priority['ticket_priority_name']);
    $ticket_priority_array[$ticket_priority['ticket_priority_id']] = $ticket_priority['ticket_priority_name'];
  }

  $ticket_statuses = array();
  $ticket_status_array = array();
  $ticket_status_query = tep_db_query("select ticket_status_id, ticket_status_name from ticket_status where ticket_language_id = '" . $languages_id . "'");
  while ($ticket_status = tep_db_fetch_array($ticket_status_query)) {
    $ticket_statuses[] = array('id' => $ticket_status['ticket_status_id'],
	'text' => $ticket_status['ticket_status_name']);
    $ticket_status_array[$ticket_status['ticket_status_id']] = $ticket_status['ticket_status_name'];
  }

  $enquiry = tep_db_prepare_input($_POST['enquiry']);
  $status = tep_db_prepare_input($_POST['status']);
  $priority = tep_db_prepare_input($_POST['priority']);
  $department = tep_db_prepare_input($_POST['department']);
  if (isset($_POST['tlid'])) $tlid =  tep_db_prepare_input($_POST['tlid']);
  if (isset($_GET['tlid'])) $tlid =  tep_db_prepare_input($_GET['tlid']);
  if (strlen($tlid) < 10) unset($tlid);
// Form was submitted
  $error = false;
  if (isset($_GET['action']) && ($_GET['action'] == 'send') && isset($tlid) ) {
  // Check Message length
    if (isset($enquiry) && strlen($enquiry) < TICKET_ENTRIES_MIN_LENGTH ) {
        $error = true;
        $_GET['error_message']=TICKET_WARNING_ENQUIRY_TOO_SHORT;
    }
    if ($error == false) { 
	$ticket_id_query = tep_db_query("select ticket_id, ticket_customers_name from ticket_ticket where ticket_link_id = '" . tep_db_input($tlid) . "'");
      $ticket_id = tep_db_fetch_array($ticket_id_query);
      if ($ticket_id['ticket_id']) {
	if (TICKET_ALLOW_CUSTOMER_TO_CHANGE_STATUS == 'false' && TICKET_CUSTOMER_REPLY_STATUS_ID > 0 ) $status = TICKET_CUSTOMER_REPLY_STATUS_ID;
	$sql_data_array = array('ticket_id' => $ticket_id['ticket_id'],
	'ticket_status_id' => $status,
	'ticket_priority_id' => $priority,
	'ticket_department_id' => $department,
	'ticket_date_modified' => 'now()',
	'ticket_customer_notified' => '0',
	'ticket_edited_by' => $ticket_id['ticket_customers_name'],
	'ticket_comments' => $enquiry);
	tep_db_perform('ticket_status_history', $sql_data_array);         
	$sql_data_array = array('ticket_status_id' => $status,
	'ticket_priority_id' => $priority,
	'ticket_department_id' => $department,
	'ticket_date_last_modified' => 'now()',
	'ticket_date_last_customer_modified' => 'now()');       
	tep_db_perform('ticket_ticket', $sql_data_array, 'update', 'ticket_id = \'' . $ticket_id['ticket_id'] . '\'');        
	$_GET['info_message']=TICKET_MESSAGE_UPDATED;

      }
    }  
  }
  $breadcrumb->add(NAVBAR_TITLE, tep_href_link('ticket_create.php'));
  require('includes/template_top.php');
?>

<h1 class="display-4"><?php echo HEADING_TITLE; ?></h1>

<div class="contentContainer">
<div class="contentText">
<?php
// Show specific Ticket  
  if (!isset($tlid)) {
?>
  <?php echo tep_draw_form('ticket_view', tep_href_link('ticket_view.php', 'action=send'), 'get', ' class="form-inline"') . "\n"; ?>
	<div class="form-group has-feedback">
	  <label for="inputFromName" class="control-label col-sm-4"><?php echo TEXT_VIEW_TICKET_NR; ?></label>
	  <div class="col-sm-5">
<?php echo tep_draw_input_field('tlid', NULL, 'required autofocus="autofocus" aria-required="true" id="inputSubject" placeholder="' . ENTRY_VIEW_TICKET_NR_TEXT . '"');
?>
</div>
</div>
	<?php echo tep_draw_button(IMAGE_BUTTON_SEARCH, 'fa fa-search', null, 'primary', null, 'btn-success'); ?>
  </form>
<?php
	if (tep_session_is_registered('customer_id')) {
	  $customers_tickets_raw = "select * from ticket_ticket where ticket_customers_id = '" . tep_db_prepare_input($customer_id) . "' order by ticket_date_last_modified desc";
	  $customers_tickets_split = new splitPageResults($customers_tickets_raw, MAX_DISPLAY_SEARCH_RESULTS);
	  if ($customers_tickets_split->number_of_rows > 0 ) {
?>
	<table class="table table-striped">
  <tr>
<td align="left"><?php echo TABLE_HEADING_NR; ?></td>
<?php 
	  if (TICKET_SHOW_CUSTOMERS_SUBJECT == 'true') { echo '            <td align="left"><' . TABLE_HEADING_SUBJECT . '></td>'; }
	  if (TICKET_CATALOG_USE_STATUS == 'true') {     echo '            <td>' . TABLE_HEADING_STATUS . '</td>'; }
	  if (TICKET_CATALOG_USE_DEPARTMENT == 'true') { echo '            <td>' . TABLE_HEADING_DEPARTMENT . '</td>'; }
	  if (TICKET_CATALOG_USE_PRIORITY == 'true') {   echo '            <td>' . TABLE_HEADING_PRIORITY . '</td>'; }
?>
<td align="right"><?php echo TABLE_HEADING_CREATED; ?></td>
<td align="right"><?php echo TABLE_HEADING_LAST_MODIFIED; ?></td>
  </tr>
<?php
	$customers_tickets_query = tep_db_query ($customers_tickets_split->sql_query);
	$number_of_tickets = 0;
	while ($customers_tickets = tep_db_fetch_array($customers_tickets_query)) {
	  $number_of_tickets++;
	  if (($number_of_tickets / 2) == floor($number_of_tickets / 2)) {
	echo '<tr>' . "\n";
} else {
   echo '<tr>' . "\n";
  }
?>
<td align="left"><?php echo '<a href="' . tep_href_link('ticket_view.php', 'tlid=' . $customers_tickets['ticket_link_id']) . '">' . $customers_tickets['ticket_link_id'] . '</a>'; ?></td>
<?php
	  if (TICKET_SHOW_CUSTOMERS_SUBJECT == 'true') { echo '            <td align="left"><a href="' . tep_href_link('ticket_view.php', 'tlid=' . $customers_tickets['ticket_link_id']) . '">' . $customers_tickets['ticket_subject'] . '</a></td>'; }
	  if (TICKET_CATALOG_USE_STATUS == 'true') {     echo '            <td>' . $ticket_status_array[$customers_tickets['ticket_status_id']] . '</td>'; }
	  if (TICKET_CATALOG_USE_DEPARTMENT == 'true') { echo '            <td>' . $ticket_department_array[$customers_tickets['ticket_department_id']] . '</td>'; }
	  if (TICKET_CATALOG_USE_PRIORITY == 'true') {   echo '            <td>' . $ticket_priority_array[$customers_tickets['ticket_priority_id']] . '</td>'; }

?>
<td align="right"><?php echo tep_date_short($customers_tickets['ticket_date_created']); ?></td>
<td align="right"><?php echo tep_date_short($customers_tickets['ticket_date_last_modified']); ?></td>
  </tr>
<?php
}
?>
</table>
<?php
	if ($customers_tickets_split->number_of_rows > 0) {
  ?>
<div class="row">
  <div class="col-sm-6 pagenumber hidden-xs">
	<?php echo $customers_tickets_split->display_count(TEXT_DISPLAY_NUMBER_OF_TICKETS); ?>
  </div>
  <div class="col-sm-6">
<div class="pull-right pagenav"><ul class="pagination"><?php echo $customers_tickets_split->display_links(MAX_DISPLAY_PAGE_LINKS, tep_get_all_get_params(array('page', 'info', 'x', 'y'))); ?></ul></div>
<span class="pull-right"><?php echo TEXT_RESULT_PAGE; ?></span>
  </div>
</div>
  <?php
  }
?>

<?php
  }
}
  }
  if (isset($tlid)) {
	  $ticket_query = tep_db_query("select * from ticket_ticket where ticket_link_id = '" . tep_db_input($tlid) . "'");
	  $ticket = tep_db_fetch_array($ticket_query);
	// Check if Customer is allowed to view ticket:
	  if ($ticket['ticket_customers_id'] > 0 && $ticket['ticket_login_required']=='1' && !tep_session_is_registered('customer_id') ) {
	  // Customer must be logged in to view ticket:
?>

  <p><?php echo sprintf(TEXT_VIEW_TICKET_LOGIN, tep_href_link('ticket_view.php', 'login=yes&tlid=' . $tlid, 'SSL'), tep_href_link('create_account.php', '', 'SSL')); ?></p>     
<?php
} else {
  // Customer is allowed to view ticket
	$ticket_status_query = tep_db_query("select * from ticket_status_history where ticket_id = '". tep_db_input($ticket['ticket_id']) . "'");
	$ticket_status = tep_db_fetch_array($ticket_status_query);
?>

<h4><?php echo sprintf(TEXT_TICKET_NR . $ticket['ticket_link_id']) . ' <span class="badge badge-secondary">' . $ticket_status_array[$ticket_status['ticket_status_id']] . '</span></h4>'; ?>
<p><?php echo '<strong>' . TEXT_OPENED . '</strong> ' . tep_date_long($ticket['ticket_date_created']); ?></p>
<?php if (TICKET_CATALOG_USE_DEPARTMENT == 'true') { ?>
<p><?php echo '<strong>' . TEXT_DEPARTMENT . '</strong> ' . $ticket_department_array[$ticket_status['ticket_department_id']]; ?></p>
<?php }
	if (TICKET_CATALOG_USE_PRIORITY == 'true') { ?>
<p><?php echo '<strong>' . TEXT_PRIORITY . '</strong> ' . $ticket_priority_array[$ticket_status['ticket_priority_id']]; ?></p>
<?php } ?>

<h4><?php echo $ticket['ticket_subject']; ?></h4>

<ul class="list-group">
<?php
  $ticket_status_query = tep_db_query("select * from ticket_status_history where ticket_id = '". tep_db_input($ticket['ticket_id']) . "'");
   while ($ticket_status = tep_db_fetch_array($ticket_status_query)) {      
	echo '<li class="list-group-item d-flex justify-content-between align-items-center">';
	echo '<h6>' . $ticket_status['ticket_edited_by'] . '</h6>';
	echo (empty($ticket_status['ticket_comments']) ? '&nbsp;' : '<p>' . tep_output_string_protected($ticket_status['ticket_comments']) . '</p>');
	echo '<span class="badge badge-primary badge-pill"><i class="far fa-clock"></i> ' . tep_date_short($ticket_status['ticket_date_modified']) . '</span>';
	echo '</li>';
}
	$ticket_last_used_status = $ticket_status['ticket_status_id'];
	$ticket_last_used_department = $ticket_status['ticket_department_id'];
	$ticket_last_used_priority = $ticket_status['ticket_priority_id'];
?>
</ul>

<?php
	echo tep_draw_form('ticket_view', tep_href_link('ticket_view.php', 'action=send')); 
	echo tep_draw_hidden_field('tlid',$tlid);
?>
  <p><?php echo '<h2>' . TEXT_COMMENT . '</h2>';
	if (TICKET_CATALOG_USE_STATUS == 'true' && TICKET_ALLOW_CUSTOMER_TO_CHANGE_STATUS == 'true') {
?>

<div class="form-group row">
    <label for="inputFromName" class="col-sm-3 col-form-label text-right"><?php echo TEXT_STATUS; ?></label>
    <div class="col-sm-9">
<?php
  echo tep_draw_pull_down_menu('status', $ticket_statuses, ($ticket_last_used_status ? $ticket_last_used_status : TICKET_DEFAULT_STATUS_ID) ) . "<br><br>";
} else {
   echo tep_draw_hidden_field('status', ($ticket_last_used_status ? $ticket_last_used_status : TICKET_DEFAULT_STATUS_ID) );
} ?>
</div>
</div>
<?php
	if (TICKET_CATALOG_USE_DEPARTMENT == 'true' && TICKET_ALLOW_CUSTOMER_TO_CHANGE_DEPARTMENT == 'true') {
?>

<div class="form-group row">
    <label for="inputFromName" class="col-sm-3 col-form-label text-right"><?php echo TEXT_DEPARTMENT; ?></label>
<div class="col-sm-9">
<?php echo tep_draw_pull_down_menu('department', $ticket_departments, ($ticket_last_used_department ? $ticket_last_used_department : TICKET_DEFAULT_DEPARTMENT_ID) ) . "<br><br>";
} else {
   echo tep_draw_hidden_field('department', ($ticket_last_used_department ? $ticket_last_used_department : TICKET_DEFAULT_DEPARTMENT_ID) );
} ?>
</div>
</div>
<?php
	if (TICKET_CATALOG_USE_PRIORITY == 'true' && TICKET_ALLOW_CUSTOMER_TO_CHANGE_PRIORITY == 'true') {
?>

<div class="form-group row">
    <label for="inputFromName" class="col-sm-3 col-form-label text-right"><?php echo TEXT_PRIORITY; ?></label>
    <div class="col-sm-9">
<?php 	
  echo tep_draw_pull_down_menu('priority', $ticket_prioritys, ($ticket_last_used_priority ? $ticket_last_used_priority : TICKET_DEFAULT_PRIORITY_ID) ) . "<br><br>";
} else {
  echo tep_draw_hidden_field('priority', ($ticket_last_used_priority ? $ticket_last_used_priority : TICKET_DEFAULT_PRIORITY_ID) );
}
?>
</div>
</div>
<div class="form-group row">
    <label for="inputFromName" class="col-sm-3 col-form-label text-right"><?php echo TEXT_COMMENT; ?></label>
    <div class="col-sm-9">
	<?php  echo tep_draw_textarea_field('enquiry', 'soft', 20, 10,'','',false); ?> 
</div>
</div>
<div class="buttonSet text-right"><?php echo tep_draw_button(BUTTON_UPDATE_TICKET, 'fa fa-send', null, 'primary', null, 'btn-success btn-block btn-lg'); ?></div>
  </form>
<?php
}
  }
?>
  </div>
</div>

<?php
  require('includes/template_bottom.php');
  require('includes/application_bottom.php');
?>
